<template>
  <q-page>
    <div class="q-pa-sm row">
      <div class="q-pa-sm col-md-8 col-xs-12">
        <div class="text-h4">{{ store.item.title }}</div>
        <div class="q-my-sm">
          <span class="text-grey">By </span>
          <b>{{ store.item.author }}</b> |
          {{ store.item.created_at }}
        </div>
        <div class="q-my-sm">
          <q-badge class="bg-pink text-white q-px-md">{{
            store.item.category
          }}</q-badge>
          | Tags:
          <i class="text-grey" v-for="tag in store.item.tags" :key="tag"
            >{{ tag + ' ' }}
          </i>
        </div>
        <div class="q-my-md">
          <image-view
            :src="store.item.thumbnail"
            :alt="placeholderImages.post"
            :ratio="2"
          />
        </div>
        <div
          class="text-grey q-py-md text-justify"
          style="line-height: 2"
          v-html="store.item.content"
        ></div>
      </div>
      <q-no-ssr>
        <div class="q-pa-sm col-md-4 col-xs-12">
          <div class="q-my-md">
            <div class="text-h6 q-pa-sm">Postingan Terbaru</div>
            <div
              class="row q-pa-sm q-my-md"
              v-for="item in news.blogs"
              :key="item.title"
            >
              <div class="col-3">
                <router-link :to="'/blog/' + item.slug">
                  <image-view
                    :src="item.thumbnail"
                    :alt="placeholderImages.post"
                    :ratio="1.25"
                  />
                </router-link>
              </div>
              <div class="col q-px-sm">
                <div class="column">
                  <div class="col text-orange">{{ item.created_at }}</div>
                  <div class="col">{{ item.title }}</div>
                  <div class="col text-grey">{{ item.author }}</div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </q-no-ssr>
    </div>
  </q-page>
</template>

<script lang="ts">
import { useInfoBlogStore } from 'stores/info-blog';
import { useLatestNewsStore } from 'stores/latest-news';
import { placeholderImages } from 'src/boot/placeholder';
import ImageView from 'src/components/ImageView.vue';

export default {
  name: 'BlogInfoPage',

  components: {
    ImageView,
  },
  setup() {
    const store = useInfoBlogStore();
    const news = useLatestNewsStore();
    return { store, news, placeholderImages };
  },
  async beforeRouteEnter(
    to: unknown,
    _prev: unknown,
    next: (r?: string) => unknown
  ) {
    try {
      const blogs = useInfoBlogStore();
      const { slug } = (to as { params: { slug: string } }).params;
      await blogs.fetchItem(slug);
      next();
    } catch (err) {
      next('/not-found');
    }
  },
  async beforeRouteUpdate(
    to: unknown,
    _prev: unknown,
    next: (r?: string) => unknown
  ) {
    try {
      const blogs = useInfoBlogStore();
      const { slug } = (to as { params: { slug: string } }).params;
      await blogs.fetchItem(slug);
      next();
    } catch (err) {
      next('/not-found');
    }
  },
};
</script>
